#ifndef INVOKESLOT_H_
#define INVOKESLOT_H_

#include "MethodCallBase.h"
#include <QList>

class QByteArray;
class QMetaObject;
class MocArgument;

class InvokeSlot : public MethodCallBase
{
public:
    InvokeSlot(Smoke *smoke, const Smoke::Stack stack, const zval* obj, zval **sp, const int slotId, const QMetaObject* metaObject, void** a, const QByteArray& slotName);
	virtual ~InvokeSlot();

	Marshall::Action action();
	zval* var();
	virtual const int items();
	void callMethod();
	bool cleanup();
	bool doAlloc() { return true; }
	bool callable(const zend_class_entry* ce);
	SmokeType type();
	Smoke::StackItem& item();

	bool makeObject;

private:
	int _items;
	int _id;
	QByteArray _slotName;
	const QMetaObject* _metaObject;
	void** _a;
	QList<MocArgument*> _mocStack;
	
	const zval* _obj;
};

#endif /*INVOKESLOT_H_*/
